/************************************************************************************/
/*  Program name CAPFAEXT_DEPRN_DETAIL.sql                                          */
/*  Creater:  NIP Karen (PCCW - UniHub)                                         	*/
/*************   History   *************************                                */
/* 21 DEC, 2005   NIP Karen         First created                               	*/
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_DEPRN_DETAIL';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_DEPRN_DETAIL.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		*
	FROM
		FA_DEPRN_DETAIL
	WHERE	SUBSTR(Book_Type_Code,1,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.BOOK_TYPE_CODE||CHR(9)||
				C1.ASSET_ID||CHR(9)||
				C1.PERIOD_COUNTER||CHR(9)||
				C1.DISTRIBUTION_ID||CHR(9)||
				C1.DEPRN_SOURCE_CODE||CHR(9)||
				C1.DEPRN_RUN_DATE||CHR(9)||
				C1.DEPRN_AMOUNT||CHR(9)||
				C1.YTD_DEPRN||CHR(9)||
				C1.DEPRN_RESERVE||CHR(9)||
				C1.ADDITION_COST_TO_CLEAR||CHR(9)||
				C1.COST||CHR(9)||
				C1.DEPRN_ADJUSTMENT_AMOUNT||CHR(9)||
				C1.DEPRN_EXPENSE_JE_LINE_NUM||CHR(9)||
				C1.DEPRN_RESERVE_JE_LINE_NUM||CHR(9)||
				C1.REVAL_AMORT_JE_LINE_NUM||CHR(9)||
				C1.REVAL_RESERVE_JE_LINE_NUM||CHR(9)||
				C1.JE_HEADER_ID||CHR(9)||
				C1.REVAL_AMORTIZATION||CHR(9)||
				C1.REVAL_DEPRN_EXPENSE||CHR(9)||
				C1.REVAL_RESERVE||CHR(9)||
				C1.YTD_REVAL_DEPRN_EXPENSE||CHR(9)||
				C1.BONUS_DEPRN_AMOUNT||CHR(9)||
				C1.BONUS_YTD_DEPRN||CHR(9)||
				C1.BONUS_DEPRN_RESERVE||CHR(9)||
				C1.BONUS_DEPRN_ADJUSTMENT_AMOUNT||CHR(9)||
				C1.BONUS_DEPRN_EXP_JE_LINE_NUM||CHR(9)||
				C1.BONUS_DEPRN_RSV_JE_LINE_NUM
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/